/* Functions: 			     			*/
/* ----------                        			*/
/* check_for_error -- makes sure all bytes were written	*/
/* checkok  -- Checks modem for 'OK' 			*/

#include <unistd.h>
#include <stdio.h>
#include "colors.h"

#define ERROR -1

void *hangup();
char *strstr();

void check_for_error(char *LogFile, int fd, int num, char *s)
{
  FILE *logfile;

  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     hangup(), close(fd), exit(ERROR);
  }

  if (num == ERROR) {
     fprintf(stderr, "%sError%s while trying to %s%s%s to/from the modem.\n", 
      	     BOLDRED, NORMAL, BOLDCYAN, s, NORMAL);
     fprintf(logfile, "Error while trying to %s to/from the modem.\n", s);
     fflush(logfile);

     hangup(), close(fd), exit(ERROR);
  }
  
  fclose(logfile);
}  

int checkok(char *LogFile, int fd, char *buf, char *s)
{
  FILE *logfile;

  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     hangup(), close(fd), exit(ERROR);
  }

  if ((strstr(buf, "OK")) == NULL) {
     #if BEEP == WANTBEEP
     putchar('\a');
     #endif

     fprintf(logfile, "The modem didn't give me an \"OK\" when %s. Aborting.\n", s);
     fprintf(stderr, "The modem didn't give me an \"%sOK%s\" when %s%s%s. %sAborting%s.\n", 
	     BOLDCYAN, NORMAL, PINK, s, NORMAL, BOLDRED, NORMAL);
     fflush(logfile);
	
     return 1;
  }

  return 0;
}
