/* 			   ShokDial                                        */
/* This is (I have never seen one anyway, I apologize if I'm wrong)  	   */
/* the first war dialer that I've ever seen for unix. This will            */
/* compile on most/all unixs' (I didn't use any spiffy or complex	   */
/* functions).	 							   */
/*  		    	    Enjoy,                                         */
/*		      Shok (Matt Conover)                                  */
/*	       shok@sekurity.org, shok@janova.org                          */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <ctype.h>
#include <signal.h>
#include <time.h>
#include "colors.h"

#define ERROR -1
#define LOGFILE "wardial.log" /* 
			       * Used as the default logfile,       
                               * unless you change this define      
                               * or specify it as an option.
                               * Type: shokdial -h for help.
			       */ 
				

#define VERSION "v3.6"
#define TIMEOUT 25     /* 
			* YOU WANT TO CONFIGURE THIS!!!
                        * This is how long it will wait until it
                        * gives up (or connects, whichever comes first
			*/

/* You can do:
 * ln -s /dev/cua1 /dev/modem
 * or change this  to /dev/cua1 (or whatever your COM is)
 * cua0 = COM1 cua1 = COM2
 * (in linux)...in IRIX this would be /dev/ttymX I believe
 */

#define MODEMPORT "/dev/modem"



/* 			Global variables			      */
/* 			----------------			      */
int  fd;                /* fd for modem      			      */
int  numbytes;          /* To verify that all the bytes were written  */
int  rand;	        /* Use random scanning if this is set         */
int  daemon;            /* Do we fork into the background?            */
int  First3Digits;      /* Such as "555" of 555-XXXX 	              */
                        /* However, this also serves as the area code */
                        /* for a long distance number                 */
int First3Digits1;      /* This allows multiple ranges such as        */
                        /* 555-XXXX through 556-XXXX                  */
int  Last3Digits;       /* Used as XXX-555-XXXX                       */
int  Last3Digits1;      /* Same purpose as First3Digits1              */
int  ScanMin;           /* Number to scan from....like 0000 and up    */
int  ScanMin1;          /* Where to hold ScanMin the whole time       */
int  ScanMax;           /* Stop scanning when this number is reached  */
char *LogFile;          /* Where to log connections 		      */
char buf[512]; 	        /* Buffer for strings returned by modem       */
char pnum[512];         /* This is the phone number from config file  */
char LocalOrLong;       /* Dialing long distance of local 	      */
char *ProgName;	  

int  noshow;            /* Don't display opening port when reopening  */
int  conf;              /* Dial using config file                     */
int  noOK;              /* Used with hanging up and checking "OK"     */
      
volatile int sig;           /* Set after signal received and finished */
volatile int connected = 0; /* Set to 1 when connected.               */

/* Some statistics.  */
int busy       = 0;
int connect    = 0;
int noresponse = 0;

/* 			Function prototypes		 	      */ 
/* 			------------------- 			      */
void usage(void);	      /*  Help/usage			      */
void version(void);           /*  Display version                     */
void intro(void);             /*  An introduction		      */
void daemonize_me(void);      /*  Fork into the background            */
void get_scanrange(void);     /*  Get the scanning range              */
void open_port(void);         /*  Open modem port for dialing	      */
void init_modem(void);        /*  Initialize the modem		      */
void dial_number(void);	      /*  Dial the number		      */
void confdial(char *confile); /*  For reading/dialing from conf file  */
void hangup(void);            /*  Hang up modem.                      */
void menu(int signum);        /*  Called when an abort is received.   */
void sighandler(int signum);  /*  Used when signals are received      */
void sighandler1(int signum); /*  Ditto                               */
void stopnow(int signum);     /*  Called from sig handler for an un-  */
                              /*  conditional exit.                   */

/* Check read/write/opens for errors  */
void check_for_error(char *LogFile, int fd, int num, char *s);

/* Check for "OK" from modem in reads */
int checkok(char *LogFile, int fd, char *buf, char *s);
 
/* Check if the phone num was valid   */ 
void local_validnum(int digits);
void long_validnum(int firstdigits, int lastdigits);

int  system();
long int random();
void strip();

void main(int argc, char **argv)
{
  int opt;
  char *confile;

  system("/usr/bin/clear");

  /* Do some stuff with the arguments                      */
  /* ----------------------------------------------------- */

  ProgName = argv[0];

  
  if (argc > 1) {
      while ((opt = getopt (argc, argv, "rdvhl:c:")) != ERROR)
 	   switch(opt)
	   {
		case 'r':
	 	    rand = 1;
	     	    break;
			
                case 'd':
		    daemon = 1;
                    break;

		case 'v': 
		    version();

		case 'h':
		    usage();

		case 'l':
		    LogFile = optarg;
		    break;
		    
		case 'c':
		    conf = 1;
		    confile = optarg;
		    break;

		case '?':
		    putchar('\n');
		    usage();

		default:
		    usage();
	  }
  }
  
  if (LogFile == NULL) {
     LogFile = LOGFILE;
     fprintf(stderr, "Using \"%s%s%s\" as log file.\n", 
   	     BOLDGREEN, LogFile, NORMAL);
  }

  if (conf != 1) 
  	fprintf(stderr, "\"%s-r%s\" (%srandom scanning%s) option not given, using %ssequential scanning%s instead.\n", 
		PINK, NORMAL, BOLDWHITE, NORMAL, BOLDRED, NORMAL);

  fprintf(stderr, "\nHit any key to continue...");
  getchar();

/* ----------------------------------------------------- */

  system("/usr/bin/clear");
	
  intro();

  system("/usr/bin/clear");

  if (conf != 1) get_scanrange();


  /* We don't want to handle any signals until here */
  signal(SIGINT,  menu);
  signal(SIGTERM, menu);
  signal(SIGHUP,  SIG_IGN);
  signal(SIGALRM, sighandler1);

  if (daemon == 1) 
     daemonize_me();    /* Run the program in the background            */

  open_port();          /* Open MODEMPORT (by default /dev/cua1)        */
  init_modem();         /* Send the modem ATZ etc..                     */

  if (conf == 1)
     confdial(confile); /* Read numbers to dial from a config file      */

  dial_number();        /* Dial the number/do the scanning              */ 
  hangup();             /* Disconnect				        */

  close(fd);
}

/* -------------------------------------------------- */

void version()
{
  fprintf(stderr, "This is %sS%sh%so%sk%sD%si%sa%sl %s%s%s...please keep notice of this.\n", 
	  BOLDCYAN, BOLDGREEN, BOLDBLUE, BOLDPINK, YELLOW, BOLDWHITE,
          BOLDRED, PINK, BOLDBLUE, VERSION, NORMAL);

  fprintf(stderr, "in case this program under goes some new features etc.\n");

  fprintf(stderr, "\t\t%s--==+*~(%sShok%s)~*+==--%s\n\n", 
	  BOLDBLUE, BOLDWHITE, BOLDBLUE, NORMAL);

  exit(0);
}

/* -------------------------------------------------- */

void usage()
{
  fprintf(stderr, "Usage: %s%s %s[-rhcvd]%s -c [config file]%s -l [logfile]%s\n\n", PINK, ProgName, BOLDWHITE, BOLDCYAN, BOLDGREEN, NORMAL);
  fprintf(stderr, "Options:\n");
  fprintf(stderr, "%s-r%s for %srandom%s (as opposed to %ssequential%s) scanning\n", BOLDCYAN, NORMAL, PINK, NORMAL, YELLOW, NORMAL);
  fprintf(stderr, "%s-h%s for %shelp%s....what you're seeing now\n", PINK, NORMAL, BOLDRED, NORMAL);
  fprintf(stderr, "%s-v%s for the %sversion%s...because this will probably undergo changes\n", BOLDGREEN, NORMAL, BOLDCYAN, NORMAL);
  fprintf(stderr, "%s-d%s to run in the %sbackground%s.\n", BLUE, NORMAL, BOLDGREEN, NORMAL);
  fprintf(stderr, "%s-c%s to read phone numbers from a %sconfig file%s.\n", YELLOW, NORMAL, BOLDCYAN, NORMAL);
  fprintf(stderr, "%s-l%s to specify the %slogfile%s.\n", BOLDRED, NORMAL, PINK, NORMAL);

  fputc('\n', stderr);

  fprintf(stderr, "The %slogfile%s is by default %s%s%s if not specified.\n", BOLDCYAN, NORMAL, BOLDGREEN, LOGFILE, NORMAL);
  fprintf(stderr, "The %sconfig file%s is only specified if %s-c%s option is used.\n", PINK, NORMAL, BOLDCYAN, NORMAL);

  fputc('\n', stderr);
  exit(1);
}

/* -------------------------------------------------- */

void intro()
{
  printf("\t\t%sS%sh%so%sk%sd%si%sa%sl%s %s%s %sf%so%sr %sU%sN%si%sX%s\n", 
	 BLINKCYAN, BOLDGREEN, BOLDBLUE, BOLDPINK, YELLOW, BOLDWHITE, BOLDRED, 
	 PINK, BOLDBLUE, VERSION, NORMAL, PINK, BOLDCYAN, BOLDGREEN, BOLDPINK, 
	 BOLDGREEN, BOLDWHITE, BOLDBLUE, NORMAL);

  printf("\t\t----------------------\n");
  printf("\nWell what you do here, is enter 0000 for the range to begin\n");
  printf("scanning and 9999 to end scanning if you want to scan all the\n");
  printf("possible ranges, but you can put 4444 for the nmber to start\n");
  printf("and 5555 for the number to begin to scan XXX-[4444-5555] for\n"); 
  printf("local numbers and it would be 1-XXX-XXX-[4444-5555] for long\n");
  printf("distance.\n");
  printf("\nAlso, you can use random scanning (as opposed to sequential\n");
  printf("scanning) by specifying the \"%s-r%s\" option...type:\n", 
	 PINK, NORMAL);

  printf("%s%s%s -h %sfor %shelp%s.\n\n", 
	 BOLDRED, ProgName, BOLDRED, NORMAL, BOLDCYAN, NORMAL);

  printf("Anyway...enjoy!\n");

  printf("\t\t%s--==+*~(%sShok%s)~*+==--%s\n\n", 
	 BOLDBLUE, BOLDWHITE, BOLDBLUE, NORMAL);
  
  printf("Hit enter to continue...\n");
  getchar();
}

/* -------------------------------------------------- */
void daemonize_me() 
{
  pid_t pid;

  if ((pid = fork()) == ERROR) {
     perror("fork");
     exit(ERROR);
  }

  if (pid != 0) 
     exit(0);
}
/* -------------------------------------------------- */
void get_scanrange()
{

  printf("Scanning..\n(%sL%s)ocal, Long (%sD%s)istance: ", 
 	 PINK, NORMAL, PINK, NORMAL);

  LocalOrLong = getchar();


  if ((LocalOrLong == 'L') || (LocalOrLong == 'l')) {
     if (rand != 1) { /* Using sequential scanning */

        printf("Enter number to begin scan on (555-1111): ");
        scanf("%3d%*c%4d", &First3Digits, &ScanMin);

        local_validnum(First3Digits); /* Make sure the first 3 digits */
                                      /* were a valid number.         */

        ScanMin1 = ScanMin; /* ScanMin changes, so we need a second   */
   		            /* variable to store the original number. */

     } else { /* Using random scanning */

        printf("Enter the first 3 digits (555 for random scanning of 555-XXXX): ");
        scanf("%3d", &First3Digits);
	  
	local_validnum(First3Digits); /* Make sure the first 3 digits */
                                      /* were a valid number.         */

        ScanMin1 = ScanMin; /* ScanMin changes, so we need a second   */
 		            /* variable to store the original number. */
     }

     /* Make sure the last 4 digits were valid */
     if ((ScanMin >= 0) && (ScanMin <= 9999)) { /* Do nothing */ }
     else {
	fprintf(stderr, "\"%s%d%s\" is invalid.\nScanning range must be %s0000-9999%s\n", 
		BOLDCYAN, ScanMin, NORMAL, PINK, NORMAL);
	exit(ERROR);
     }

     if (rand != 1) { /* Using sequential scanning */

        printf("Enter number to end scanning on (555-9999): ");
        scanf("%3d%*c%4d", &First3Digits1, &ScanMax);

        local_validnum(First3Digits1); /* Make sure the first 3 digits */
                                       /* were a valid number.         */ 
        putchar('\n');
  
        if ((ScanMax >= ScanMin) && (ScanMax >= 0) && (ScanMax <= 9999));
	   /* Do nothing */ 
        else {
  	   fprintf(stderr, "\"%s%d%s\" is invalid.\n Scanning range must be %s0000-9999%s, and the %smaximum%s range must be %sgreater%s\nthan or equal to the %sminimum%s number.\n", 
		  BOLDCYAN, ScanMax, NORMAL, BOLDWHITE, NORMAL, PINK,
		  NORMAL, BOLDWHITE, NORMAL, PINK, NORMAL);

		exit(ERROR);
        }
     } else 
	putchar('\n');


  /* -------------------- */

  } else if ((LocalOrLong == 'D') || (LocalOrLong == 'd')) {

      if (rand != 1) { /* Use sequential scanning */
 	 printf("Enter number to start scanning (555-555-1111): ");
  	 scanf("%3d%*c%3d%*c%4d", &First3Digits, &Last3Digits, &ScanMin);

         /* Check if area code and first 3 digits of the phone num are */
         /* valid.						        */
	 long_validnum(First3Digits, Last3Digits);

         ScanMin1 = ScanMin; /* ScanMin changes, so we need a second   */
	  	             /* variable to store the original number. */

        /* ... */

      } else { /* Using random scanning */

	 printf("Enter the area code and prefix digits\n(555-555 for random scanning of 555-555-XXXX): ");
         scanf("%3d%*c%3d", &First3Digits, &Last3Digits);

         /* Check if area code and first 3 digits of the phone num are */
         /* valid.						       */
  	 long_validnum(First3Digits, Last3Digits);
 
         ScanMin1 = ScanMin; /* ScanMin changes, so we need a second   */
 		             /* variable to store the original number. */
      }

      /* Make sure the last 4 digits were valid */
      if ((ScanMin >= 0) && (ScanMin <= 9999));
         /* Do nothing */
      else {
 	 fprintf(stderr, "\"%s%d%s\" is invalid.\nScanning range must be %s0000-9999%s\n", 
	 	 BOLDCYAN, ScanMin, NORMAL, PINK, NORMAL);
	 exit(ERROR);
      }

      if (rand != 1) { /* Using sequential scanning */

	 printf("Enter number to end scanning (555-555-9999): ");
  	 scanf("%3d%*c%3d%*c%4d", &First3Digits1, &Last3Digits1, &ScanMax);

  	 putchar('\n');
  
         /* Check if area code and first 3 digits of the phone num are */
         /* valid.						      */
  	 long_validnum(First3Digits1, Last3Digits1);

         if ((ScanMax >= ScanMin) && (ScanMax >= 0) && (ScanMax <= 9999));
            /* Do nothing */ 
         else {
   	    fprintf(stderr, "\"%s%d%s\" is invalid.\n Scanning range must be %s0000-9999%s, and the %smaximum%s range must be %sgreater%s\nthan or equal to the %sminimum%s number.\n", 
		    BOLDCYAN, ScanMax, NORMAL, BOLDWHITE, NORMAL, PINK,
		    NORMAL, BOLDWHITE, NORMAL, PINK, NORMAL);

	    exit(ERROR);
  	 }
      } else 
  	   putchar('\n');

  } else {
       fprintf(stderr, "You must specify \"%sL%s\" for %slocal%s or \"%sD%s\" for %slong distance%s\n", 
	       PINK, NORMAL, BOLDCYAN, NORMAL, PINK, NORMAL, BOLDCYAN, NORMAL);
       exit(ERROR);
  }

}

/* -------------------------------------------------- */

void open_port()
{
  if (noshow != 1) printf("Opening modem for dialing...\n");

  fd = open(MODEMPORT, O_RDWR);

  if (fd == ERROR) {
     perror("open");
     exit(ERROR);
  }
  
  noshow = 1; /* We use this function for reopening as well */
}

/* -------------------------------------------------- */

void init_modem()
{
  FILE *logfile;

  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     close(fd);
     exit(ERROR);
  }

  printf("Initializing modem (port %s%s%s)....\n", PINK, MODEMPORT, NORMAL);

  /* Hang up modem if it's already on */
  
  hangup();

  numbytes = write(fd, "+++\r", 4);
  check_for_error(LogFile, fd, numbytes, "write");
  usleep(1000000);

  numbytes = write(fd, "ATZ\r", 4);
  check_for_error(LogFile, fd, numbytes, "write");
  usleep(2000000); /* Use this because we're using SIGALRM which   */
		   /* is what sleep() uses.			   */

  bzero(buf, sizeof(buf));
  numbytes = read(fd, buf, sizeof(buf));
  check_for_error(LogFile, fd, numbytes, "read");

  noOK = checkok(LogFile, fd, buf, "initializing modem");
  
  if (noOK == 1) {
     fclose(logfile);
     close(fd);
     exit(ERROR);
  }

  bzero(buf, sizeof(buf));

  fclose(logfile);
}

/* -------------------------------------------------- */

void dial_number()
{
  time_t tm;           /* Where we our calendar time is stored		*/
  FILE   *logfile;     /* for the log file 	   		        */
  char   date[32];     /* Contain time scanning started/stopped         */
  char   phonenum[20]; /* If local: phonenum = First3Digits + ScanMin   */
                       /* If long distance: phonenum =                  */
                       /* First3Digits + Last3Digits + ScanMin          */
    
  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     exit(ERROR);
  }

  fprintf(logfile, "\n----------------------\n\n");
  fflush(logfile);

  bzero(buf, sizeof(date));
  bzero(buf, sizeof(buf));

  tm = time(NULL);
  sprintf(date, "%s", ctime(&tm));
  fprintf(logfile, "Started scanning at/on: %s", date);

  fflush(logfile);
  bzero(date, sizeof(date));

  if (daemon == 1) putchar('\n'); /* Just to make it look nicer */

  printf("Using a %s%d%s second connection %stimeout%s.\n", 
	 BOLDCYAN, TIMEOUT, NORMAL, BOLDWHITE, NORMAL);

  
  if ((LocalOrLong == 'L') || (LocalOrLong == 'l')) {  /* Local call */

     fprintf(logfile, "Scanning local numbers...\n");
     fprintf(logfile, "Using a %d second connection timeout.\n", TIMEOUT);
     fprintf(logfile, "Starting scanning with %d-%.4d\n\n", 
	     First3Digits, ScanMin);

     fflush(logfile);

     while (1) {
        if (rand == 1) ScanMin = (random() % 8889) + 11;

      	printf("Dialing %s%d-%.4d%s...\n", 
	       PINK, First3Digits, ScanMin, NORMAL);

	bzero(phonenum, sizeof(phonenum));
	sprintf(phonenum, "ATDT%d%.4d\r", First3Digits, ScanMin);

       	numbytes = write(fd, phonenum, strlen(phonenum));
	check_for_error(LogFile, fd, numbytes, "write");

	bzero(buf, sizeof(buf));

        alarm(TIMEOUT); /* How long to wait for timeout   */

	sig = 0;
        connected = 1; /*  
			* Easier to set it to 1 and then set it
			* to 0 if it's not than vice versa.
			*/
	do {
           numbytes = read(fd, buf, 511);
	   if (sig == 1) break;
			
	} while ((strstr(buf, "CONNECT")) == NULL);

	alarm(0); /* Turn alarm off if we haven't already. */

	if (connected == 0) noresponse++;
	else if ((strstr(buf, "BUSY")) != NULL) busy++;

       	/* Compare the string with "CONNECT" */
        if (connected == 1) { /* Sighandler sets this to 0 when  */
			      /* it's called...meaning time out. */
  	   #ifdef BEEP
           fputc('\a', stderr);
           #endif

	   connect++;

           fprintf(logfile, "*** CONNECT *** to %d-%.4d\n",  
		   First3Digits, ScanMin);

 	   fprintf(stderr, "%s*** %sCONNECT %s%s*** %s to %s%d-%.4d%s\n", 
	 	   BOLDWHITE, BOLDCYAN, NORMAL, BOLDWHITE, NORMAL, 
		   PINK, First3Digits, ScanMin, NORMAL);
        }

        bzero(buf, sizeof(buf)); 

	hangup();

	if (rand != 1) {
	   /* Increase ScanMin so it scans for the next number */
	   ScanMin++;
            
           if (ScanMin > ScanMax) {
 	      /* If they are different...then they are scanning */
              /* something like: 555-XXXX through 556-XXXX.     */
   
              /* So now we reset everything.       */

              /* 
               * If you did: 755-XXXX through 757-XXXX, we need to 
               * increase the 755 and repeat until they are the same. 
               */

               if (First3Digits !=  First3Digits1) {

   	          First3Digits++; 
	          ScanMin = ScanMin1; /* Restored ScanMin to its */
                                      /* original value.         */
  	          continue;
	       }

	       bzero(buf, sizeof(buf));

	       #ifdef BEEP
               fputc('\a', stderr);
	       #endif

	       fprintf(logfile, "\nFinished scanning %d-%.4d through %d-%d.\n", 
   		       First3Digits, ScanMin1, First3Digits, ScanMax);
				
	       bzero(date, sizeof(date));
	       tm = time(NULL);
	       sprintf(date, "%s", ctime(&tm));

	       fprintf(logfile, "Finished at/on: %s", date);
	       fflush(logfile);				

	       fprintf(stderr, "Finished scanning %s%d-%.4d %sthrough %s%d-%.4d%s.\n", 
		       BOLDCYAN, First3Digits, ScanMin1, NORMAL, 
		       BOLDCYAN, First3Digits, ScanMax,  NORMAL);

     	       /* Print statistics. */
   	       fprintf(stderr, "%sResults%s:\n", BOLDRED, NORMAL);

	       fprintf(stderr, "\t# of %ssuccessful connects%s: %s%d%s\n", 
	               BOLDCYAN, NORMAL, PINK, connect, NORMAL);

	       fprintf(stderr, "\t# of lines %sbusy%s: %s%d%s\n", 
	               YELLOW, NORMAL, PINK, busy, NORMAL);

	       fprintf(stderr, "\t# of %sno responses (timed out)%s: %s%d%s\n", 
		       BOLDGREEN, NORMAL, PINK, busy, NORMAL);


  	       fprintf(stderr, "Thanks for using %sS%sh%so%sk%sD%si%sa%sl %s%s%s.\n", 
 		       BLINKCYAN, BOLDGREEN, BOLDBLUE, BOLDPINK, YELLOW, 
                       BOLDWHITE, BOLDRED, PINK, BOLDBLUE, VERSION, NORMAL);

	       exit(0);
           } 
        }

	bzero(phonenum, sizeof(phonenum));

    }
  } else { /* (Long Distance call) */ 

        bzero(buf, sizeof(buf));

	fprintf(logfile, "Scanning long distance numbers...\n");

        fprintf(logfile, "Using a %s%d%s second connection %stimeout%s.\n",
		BOLDCYAN, TIMEOUT, NORMAL, BOLDWHITE, NORMAL);

	fprintf(logfile, "Started scanning with 1-%d-%d-%.4d\n\n", 
		First3Digits, Last3Digits, ScanMin);

        fflush(logfile);

	while(1) {
  	   if (rand == 1) ScanMin = (random() % 8889) + 1111;

	   printf("Dialing %s1-%d-%d-%.4d%s...\n", 
	  	  PINK, First3Digits, Last3Digits, ScanMin, NORMAL);

 	   bzero(phonenum, sizeof(phonenum));
	   sprintf(phonenum, "ATDT1%d%d%.4d\r", 
		   First3Digits, Last3Digits, ScanMin);

           numbytes = write(fd, phonenum, strlen(phonenum));
           check_for_error(LogFile, fd, numbytes, "write");
               
           bzero(buf, sizeof(buf));

           alarm(TIMEOUT); /* How long to wait for timeout. */

           sig = 0;
           connected = 1; /* 
                           * Easier to say it's connected and then
                           * set it to 0 if it's not than vice versa.
                           */
           do {
              numbytes = read(fd, buf, 511);
	      if (sig == 1) break;
           } while ((strstr(buf, "CONNECT")) == NULL); 
	
 	   alarm(0);

	   if (connected == 0) noresponse++;
	   else if ((strstr(buf, "BUSY")) != NULL) busy++;

           if (connected == 1) { /* The sighandler sets this to 0 when */
				 /* it gets called.                    */

	      #ifdef BEEP
              fputc('\a', stderr);
	      #endif

     	      connect++;

 	      fprintf(logfile, "*** CONNECT *** to 1-%d-%d-%.4d\n", 
		      First3Digits, Last3Digits, ScanMin);
	      fflush(logfile);

	      fprintf(stderr, "%s*** %sCONNECT %s%s*** %sto %s1-%d-%d-%.4d%s\n",
		      BOLDWHITE, BOLDCYAN, NORMAL, BOLDWHITE, NORMAL, PINK,
		      First3Digits, Last3Digits, ScanMin, NORMAL); 

           }

           bzero(buf, sizeof(buf));

	   hangup(); 

           if (rand != 1) {

              /* Increase ScanMin so it scans for the next number */
      	      ScanMin++;
                        
             if (ScanMin > ScanMax) {

		/* If they are different...then they are scanning */
                /* something like: 555-XXXX through 556-XXXX.     */
  
                /* So now we reset everything.       */

                /* 
                 * If you did: 555-755-XXXX through 
                 * 555-757-XXXX, we need to increase 
                 * the 755 and repeat until they are the
                 * same. 
                 */

                 if ((First3Digits !=  First3Digits1) || \
	             (Last3Digits  !=  Last3Digits1)) {

		    if (First3Digits != First3Digits1) First3Digits++;
		    if (Last3Digits  != Last3Digits1)  Last3Digits++;

		    ScanMin = ScanMin1; /* Restore to its original value */
		    continue;
		 }

		 bzero(buf, sizeof(buf));

		 #ifdef BEEP
                 fputc('\a', stderr);
		 #endif 

		 fprintf(logfile, "\nFinished scanning 1-%d-%d-%.4d through 1-%d-%d-%.4d.\n", 
 			 First3Digits, Last3Digits, ScanMin1, First3Digits, 
                         Last3Digits, ScanMax);
				
 		 bzero(date, sizeof(date));
		 tm = time(NULL);
		 sprintf(date, "%s", ctime(&tm));
			
		 fprintf(logfile, "Finished at/on: %s", date); 
		 fflush(logfile);

		 fprintf(stderr, "Finished scanning %s1-%d-%d-%.4d%s through %s1-%d-%d-%.4d%s", 
 			 BOLDCYAN, First3Digits, Last3Digits, ScanMin1, 
			 NORMAL, BOLDCYAN, First3Digits, Last3Digits, 
			 ScanMax, NORMAL);

		 /* Print statistics. */
		 fprintf(stderr, "%sResults%s:\n", BOLDRED, NORMAL);

	         fprintf(stderr, "\t# of %ssuccessful connects%s: %s%d%s\n", 
		         BOLDCYAN, NORMAL, PINK, connect, NORMAL);

  		 fprintf(stderr, "\t# of %sno responses (timed out)%s: %s%d%s\n", 
		        YELLOW, NORMAL, PINK, busy, NORMAL);

  		 fprintf(stderr, "\t# of %sno responses (timed out)%s: %s%d%s\n", 
		        BOLDGREEN, NORMAL, PINK, noresponse, NORMAL);


                 fprintf(stderr, "Thanks for using %sS%sh%so%sk%sD%si%sa%sl %s%s%s\n", 
		 	 BLINKCYAN, BOLDGREEN, BOLDBLUE, BOLDPINK, YELLOW, 
                         BOLDWHITE, BOLDRED, PINK, BOLDBLUE, VERSION, NORMAL);


                 break;
             }
 	  }

          bzero(phonenum, sizeof(phonenum));
        } 
  } 

  fclose(logfile);
} 

/* --------------------------------------- */

void hangup()
{
  FILE *logfile;

  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     exit(ERROR);
  }
    
  /* 
   * The reason we write "ATH" to a nonconnected host is that
   * this is fine. But when it's connected... +++ is sent as
   * the login name, and ATH as the password (not a good thing
   * to be logged on a remote host anyway. ;)
   * If it is connected we will take the less effecient method
   * of closing and reopening the fd to hang up
   */
 
  if (connected != 1) {
     numbytes = write(fd, "+++\r", 4);
     check_for_error(LogFile, fd, numbytes, "write");

     usleep(1000000);
     bzero(buf, sizeof(buf));

     numbytes = write(fd, "ATH\r", 4);
     check_for_error(LogFile, fd, numbytes, "write");


     /* 
      * We're using SIGALRM, and sleep() uses sig alarm
      * and usleep() doesn't. 				
      */

     usleep(1000000); 

     numbytes = read(fd, buf, sizeof(buf));
     check_for_error(LogFile, fd, numbytes, "read");
     usleep(2000000);

     if (noOK != 1) noOK = checkok(LogFile, fd, buf, "hanging up modem");
     else {
        /* There was an error getting an "OK" from the modem */
        fclose(logfile);
        close(fd), exit(ERROR);
     }

     if (noOK == 1) {
        /* There was an error getting an "OK" from the modem */
        fclose(logfile);
        close(fd), exit(ERROR);
     }

  } else {
      close(fd);
      open_port();
      connected = 0;
  }

  bzero(buf, sizeof(buf));
  fclose(logfile);
}

/* -------------------------------------- */

void confdial(char *confile)
{
  time_t tm;           /* Where we our calendar time is stored		*/
  FILE   *logfile;     /* For the log file 	   		        */
  FILE   *confd;       /* For the config file                           */
  char   date[32];     /* Contain time scanning started/stopped         */
  char   pnum1[20];    /* Phone # without the '-'s and what not.        */
  char   phonenum[20]; /* This will include the ATDT etc.               */
    
  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     exit(ERROR);
  }

  fprintf(logfile, "\n----------------------\n\n");
  fflush(logfile);

  if ((confd = fopen(confile, "r")) == NULL) {
     perror("fopen");
     exit(ERROR);
  }

  bzero(date, sizeof(date));
  bzero(buf,  sizeof(buf));

  tm = time(NULL);
  sprintf(date, "%s", ctime(&tm));

  printf("Reading phone numbers from \"%s%s%s\".\n", PINK, confile, NORMAL);
  fprintf(logfile, "Started at/on: %s\n"
		   "Reading phone numbers from config file \"%s\".\n", 
	            date, confile);

  fflush(logfile);
  bzero(date, sizeof(date));

  if (daemon == 1) putchar('\n'); /* Just to make it look nicer */

  printf("Using a %s%d%s second connection %stimeout%s.\n", 
	 BOLDCYAN, TIMEOUT, NORMAL, BOLDWHITE, NORMAL);

  
  bzero(phonenum, sizeof(phonenum));
  bzero(pnum1,    sizeof(pnum1));

  while (!feof(confd)) {
     if ((fgets(pnum, 512, confd)) == NULL) {
	perror("fgets");
	exit(ERROR);
     }

     if (pnum[0] == '\n')
	continue;

     if ((strstr(pnum, "#")) != NULL) {

	if (pnum[0] == '#')
 	   continue; 
	else {
	   /* Well either there are some spaces, or a */
	   /* number before the comment               */

	   char *p, *p1;
	   char temp[20];

	   bzero(temp, sizeof(temp));

	   p = pnum, p1 = temp;

 	   while(*p == '\t' || *p == ' ')
	      *p += 1;

	      if (*p == '#') /* Just some space and a comment */
	 	 continue;
              else { /* Okay it's a number */
	         while(*p != '\t' || *p != ' '  || \
                       *p != '\n' || *p != '\0' || *p != '#')
		    *p1++ = *p++;

		    sprintf(pnum, "%s", temp);	
				
	      }
	}

     }

     fprintf(logfile, "Dialing %s\n", pnum);
     fflush(logfile);

     strip(pnum, pnum1);

     printf("Dialing %s%s%s\n", BOLDCYAN, pnum, NORMAL);

     sprintf(phonenum, "ATDT%s\r", pnum1);

     numbytes = write(fd, phonenum, strlen(phonenum));
     check_for_error(LogFile, fd, numbytes, "write");

     bzero(buf, sizeof(buf));

     alarm(TIMEOUT); /* How long to wait for timeout   */

     sig = 0;
     connected = 1; /* 
        	     * Easier to set it to 1 and then set it
		     * to 0 if it's not than vice versa
		     */

     do {
        numbytes = read(fd, buf, 511);
	if (sig == 1) break;
     } while ((strstr(buf, "CONNECT")) == NULL);

     alarm(0); /* Stop the timing. */

     /* Compare the string with "CONNECT" */
     if (connected == 1) {
	#ifdef BEEP
        fputc('\a', stderr);
	#endif

        fprintf(logfile, "*** CONNECT *** to %s", pnum);
	fprintf(stderr, "%s*** %sCONNECT %s%s*** %s to %s%s%s\n", 
		BOLDWHITE, BOLDCYAN, NORMAL, BOLDWHITE, NORMAL, 
		PINK, pnum, NORMAL);
     }

     bzero(buf, sizeof(buf));

     hangup();
  }

  #ifdef BEEP
  fputc('\a', stderr);
  #endif

  bzero(date, sizeof(date));
  tm = time(NULL);
  sprintf(date, "%s", ctime(&tm));

  fprintf(logfile, "Finished dialing at/on: %s", date);
  fflush(logfile);				

  fprintf(stderr, "Finished dialing!!.\n"); 

  fprintf(stderr, "Thanks for using %sS%sh%so%sk%sD%si%sa%sl %s%s%s.\n", 
 	  BLINKCYAN, BOLDGREEN, BOLDBLUE, BOLDPINK, YELLOW, BOLDWHITE, 
          BOLDRED, PINK, BOLDBLUE, VERSION, NORMAL);

  fclose(logfile);
  exit(0);
} 

/* -------------------------------------- */

/* The reason I have two different sighandler functions, rather than */
/* just basing off the signal number, is simplicity.                 */


void sighandler(int signum)
{
  FILE   *logfile;
  char   date[32]; /* Where the date for the ending time is stored. */
  time_t tm;       /* Where calendar time is stored.                */

  bzero(date, sizeof(date));

  /* Just exit on one of these signals. */
  signal(SIGINT,  stopnow);
  signal(SIGTERM, stopnow);

  tm = time(NULL);
  sprintf(date, "%s", ctime(&tm));

  if ((logfile = fopen(LogFile, "a")) == NULL) {
     perror("fopen");
     exit(ERROR);
  }

  fprintf(stderr, "%sReceived signal to quit%s:\nClosing up modem, logging, and exitting.\n", 
	  BOLDRED, NORMAL);
  fprintf(logfile, "\nReceived signal to quit. Aborting.\n");
  fflush(logfile);

  if (conf == 1) {
     fprintf(logfile, "Last number dialed was %s", pnum);
     close(fd);
     fclose(logfile);
     exit(ERROR);
  }

  if ((LocalOrLong == 'L') || (LocalOrLong == 'l')) {
     if (rand != 1 || conf != 1) {
	fprintf(logfile, "Last number dialed was %d-%.4d.\n", 
                First3Digits, ScanMin);

        fprintf(stderr, "Last number dialed was %s%d-%.4d%s.\n", 
		BOLDCYAN, First3Digits, ScanMin, NORMAL);
     }

     fprintf(logfile, "Results:\n");
     fprintf(logfile, "\t# of successful connects: %d\n", connect);
     fprintf(logfile, "\t# of busy numbers: %d\n", busy);
     fprintf(logfile, "\t# of no responses (timed out): %d\n", noresponse);

  } else { /* if LocalOrLong == 'D' */
       if (rand != 1 || conf != 1) {
 	  fprintf(logfile, "Last number dialed was 1-%d-%d-%.4d.\n", 
	  	  First3Digits, Last3Digits, ScanMin);

	  fprintf(stderr, "Last number dialed was %s1-%d-%d-%.4d%s.\n", 
		  BOLDCYAN, First3Digits, Last3Digits, ScanMin, NORMAL);
       }

       fprintf(logfile, "Results:\n");
       fprintf(logfile, "\t# of successful connects: %d\n", connect);
       fprintf(logfile, "\t# of busy numbers: %d\n", busy);
       fprintf(logfile, "\t# of no responses (timed out): %d\n", noresponse);

  }

  /* Print statistics. */
  fprintf(stderr, "%sResults%s:\n", BOLDRED, NORMAL);

  fprintf(stderr, "\t# of %ssuccessful connects%s: %s%d%s\n", 
          BOLDCYAN, NORMAL, PINK, connect, NORMAL);

  fprintf(stderr, "\t# of %sno responses (timed out)%s: %s%d%s\n", 
          YELLOW, NORMAL, PINK, busy, NORMAL);

  fprintf(stderr, "\t# of %sno responses (timed out)%s: %s%d%s\n", 
          BOLDGREEN, NORMAL, PINK, noresponse, NORMAL);


  fprintf(logfile, "Aborted at: %s", date);
  fflush(logfile);

  noshow = 1; /* So we don't get 'Opening modem for dialing' because  */
              /* we use open_port() for both hanging up and dialing.  */
  hangup();

  close(fd);
  fclose(logfile);

  exit(0);
}

/* -------------------------------------- */

void sighandler1(int signum)
{  
   sig = 1;
   connected = 0;
}

/* -------------------------------------- */
 
void menu(int signum)
{
  char ch;

  signal(SIGINT, sighandler);
  signal(SIGTERM, sighandler);

  printf("\n\n1. Hang up modem and skip to next number\n");
  printf("2. Hang up modem and exit\n\n");
  printf("Enter 1 or 2: ");

  while (1) {
     fflush(stdout);
  
     ch = getchar();

     if (ch == '1') {

        printf("char was 1\n");

        /* Just act like the number timed out. sighandler1 is */
        /* the sig handler called when a number times out.    */
        sighandler1(0); 

        /* Reset signal handlers. */
        signal(SIGINT,  menu);
        signal(SIGTERM, menu);

        break;
     } else if (ch == '2') {
        /* Sig handler used to exit. So we will just call this. */
        sighandler(0); 

     } else
	if (isprint(ch)) printf("Invalid option.\nEnter 1 or 2: ");
  }
}

void stopnow(int signum)
{
  /* Exit without any condition. */
  exit(ERROR);
}

