/* This is just a little program that plays with your keyboard lights */
/* while playing sound tones. Maybe I will make it play a song some-  */
/* time! 							      */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <sys/stat.h>
#include <linux/kd.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#define ERROR -1

int fd;

void sighandler(int signum);

void main()
{
  int it = 0x02;
  int j, k, l;

  fd = open("/dev/console", O_RDONLY | O_NOCTTY);

  /* if (fork() != 0) exit(0); */

  printf("w00w00!.\n\n");

  signal(SIGINT,  sighandler);
  signal(SIGTERM, sighandler);

  printf("For the best sounding one, use the example values shown.\n");

  while (1) {
     printf("Enter range to scan (i.e. 100-3000): ");
     scanf("%d%*c%d", &j, &k);

     printf("Enter intervals to skip (i.e. 10): ");
     scanf("%d", &l);

     printf("Doing %d through %d, with an interval of %d:\n\n", j, k, l);

     for (; j <= k; j += l) {

        for (it = 0x01; it <= 0x04; it++) {
           if (it == 0x03) continue;

           usleep(10000);

           if ((ioctl(fd, KDSETLED, it)) == ERROR) {
              perror("ioctl");
              close(fd);
              exit(ERROR);
           }

        }

        if ((ioctl(fd, KIOCSOUND, j)) == ERROR) {
          perror("ioctl");
          close(fd);
          exit(ERROR);
        }

        printf("tone = %d\n", j);

        if (j == k) break;
        usleep(70000);

     }

     /* Turn off all sound. */
     if ((ioctl(fd, KIOCSOUND, 0x0)) == ERROR) {
       perror("ioctl");
       close(fd);
       exit(ERROR);
     }

     /* Turn off all leds. */
     if ((ioctl(fd, KDSETLED, 0x0)) == ERROR) {
       perror("ioctl");
       close(fd);
       exit(ERROR);
     }

     putchar('\n');
  }

  close(fd);
}

void sighandler(int signum)
{
  /* Stop all sound. */
  if ((ioctl(fd, KIOCSOUND, 0x0)) == ERROR) { 
    perror("ioctl");
    close(fd);
    exit(ERROR);
  }

  /* Turn off all leds. */
  if ((ioctl(fd, KDSETLED, 0x0)) == ERROR) { 
    perror("ioctl");
    close(fd);
    exit(ERROR);
  }

  printf("\nw00w00!\n");
  close(fd);
  exit(0);
}
