/* w00w00! */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <pwd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
       
#define USERFILE "/etc/rootusers"
#define SUIDFILE "/etc/suid"
#define MAILUSER "whoever@whoever.net"
#define ERROR    -1

struct statusinfo {
  char cmd[256];
  int uid, euid;
  int pid, ppid;   
};

char *suids[64], *rootusers[32]; /* more?! */

char *gettime(void);
char *getline(char *b);

void strip(char *p);
void checkcfg(void);
void clearlists(void);
void trace_and_kill(int pid);
void stok(char *string, char *put, int j);
void itok(char *string, int  *put, int j);
void do_report(char *cmd, int uid, int euid);
void do_check(char *cmd, int uid, int pid, int ppid);

struct statusinfo *woop(char *buf);
struct statusinfo *getnextpid(int pid);

void checkcfg(void)
{
  FILE *mf;
  char buf[512];
  int i;

  for(i = 0; i < 32; i++) rootusers[i]=NULL;
  for(i = 0; i < 64; i++) suids[i]=NULL;

  i = 0;
  
  bzero(suids, sizeof(suids));
  bzero(rootusers, sizeof(rootusers));

  if ((mf = fopen(USERFILE, "r")) == NULL) {
	perror("fopen");
	exit(ERROR);
  }

  while (fgets(buf, 256, mf)) {
      if ((rootusers[i] = malloc(10)) == NULL) {
	 perror("malloc");
	 fclose(mf);
	 exit(ERROR);
      }

      strcpy(rootusers[i], buf);
      strip(rootusers[i]);
      i++;
  }
  
  fclose(mf);

  i = 0;

  if((mf = fopen(SUIDFILE, "r")) == NULL) {
	perror("fopen");
	exit(ERROR);
  }

  while (fgets(buf, 10, mf)) {
      if ((suids[i] = malloc(256)) == NULL) {
	perror("malloc");
	fclose(mf);
	exit(ERROR);
      }

      strncpy(suids[i], buf, sizeof(suids[i]));
      strip(suids[i]);
      i++;
  }

  fclose(mf);
}

void strip(char *p)
{
  for(; *p && *p != '\n'; p++);
  *p = 0;
}

void huph(void)
{
  clearlists();
  checkcfg();
}

void clearlists(void)
{
  int i;

  for(i = 0; rootusers[i]; i++) free(rootusers[i]);
  for(i = 0; suids[i]; i++) free(suids[i]);
}

void main(int argc, char **argv)
{
  int i;

  FILE *status;
  DIR  *procshit;

  struct dirent *currproc;
  struct stat statshit, p;
  int pid, ppid, uid, euid; 
  char buf[256], q[512], cmd[256];
  
  time_t nt, ot;

  if (geteuid() != 0) {
     printf("Needs to be run as roon.\n");
     exit(ERROR);
  }

  checkcfg();
  signal(SIGHUP,(void *)huph);
  if(fork() != 0)
    exit(0);

  nt = time(NULL);
  
  while(1) {
    if ((procshit = opendir("/proc")) == NULL) {
       printf("Can't open /proc?!\n");
       exit(ERROR);
    }

    while((currproc=readdir(procshit)) != NULL) {
      sprintf(buf, "/proc/%s", currproc->d_name);
      stat(buf, &statshit);

      sprintf(q, "/proc/%s/status", currproc->d_name);

      if ((i = stat(q,&p)) != ERROR && \
           strcmp("self",currproc->d_name) != 0) { 
        if ((status = fopen(q,"r")) == NULL) break;

        fgets(q, 512, status);
        stok(q, cmd, 1);

        fgets(q, 512, status);
        fgets(q, 512, status);
        itok(q, &pid, 1);
 
        fgets(q, 512, status);
        itok(q, &ppid, 1);

        fgets(q, 512, status);
        itok(q, &uid, 1);
        itok(q, &euid, 2);

        if (euid == 0 && pid != getpid() && ppid != getpid())
           do_check(cmd, uid, pid, ppid);

        fclose(status);
      }
    }

    closedir(procshit);

    ot = time(NULL);

    if (ot - 60 >= nt) {
       huph();
       nt=time(NULL);
    }

    sleep(2);
  }
}

void do_check(char *cmd, int uid, int pid, int ppid)
{
  struct statusinfo *sinfo;

  if ((sinfo = getnextpid(pid)) == NULL)
    return;
  
  if(!checkuser(sinfo->uid) && !checksuid(cmd)) {
    do_report(cmd, sinfo->uid, 0);    
    trace_and_kill(pid);
  }  
}

int checkuser(int uid)
{
  int i;
  struct passwd *pw;

  pw = getpwuid(uid);
  if(!pw) return 0; /* not in passwd?! kill him! */

  for(i = 0; rootusers[i]; i++)
    if(strcmp(rootusers[i], pw->pw_name) == 0)
      return 1;

  return 0;  
}

int checksuid(char *base)
{
  int i;
  for(i = 0; suids[i]; i++) 
    if(strcmp(suids[i], base) == 0)
      return 1;

  return 0;
}

void stok(char *string, char *put, int j)
{
  int i; 
  char *p[256];

  p[i=0]=strtok(string,"	");
  while((p[++i]=strtok(NULL,"	")));
  p[i]=NULL;

  strncpy(put, p[j], sizeof(put));

  *(put+strlen(put)-1) = 0;
}

void itok(char *string, int *put, int j)
{
  int i;
  char *p[256];

  p[i=0]=strtok(string,"	");
  while((p[++i]=strtok(NULL,"	")));
  p[i]=NULL;

  *put=atoi(p[j]);
}

void do_report(char *cmd, int uid, int euid)
{
  int i;
  FILE *wee;
  struct passwd *pw;
  char fil[64], buf[512];

  srand(time(NULL));

  pw = getpwuid(uid);
  i  = rand();
  sprintf(fil, "/tmp/%d%d", getpid(), i);

  if ((wee = fopen(fil, "w")) == NULL)
	perror("fopen"); /* We don't want to exit here. */

  /* I apologize for the ugliness of this section but it was the */
  /* easiest way to do it.                                       */

  sprintf(buf,"At %s %s[%d] got euid %d by running %s\n",
          gettime(), pw->pw_name, uid, euid, cmd);

  fputs(buf, wee);
  sprintf(buf, "netstat, tcpdump, [uw]tmp, etc. data follows:\n");
  fputs(buf, wee);
  
  sprintf(buf, "echo -e \"\nnetstat output:\n\" > /tmp/netstat%d", i);
  system(buf);

  sprintf(buf, "netstat -a -n >> /tmp/netstat%d", i);
  system(buf);


  sprintf(buf, "echo -e \"\n'last' output:\n\" > /tmp/last%d", i);
  system(buf);

  sprintf(buf, "last -5 >> /tmp/last%d", i);
  system(buf);


  sprintf(buf, "echo -e \"\n'w' output:\n\" > /tmp/who%d", i);
  system(buf);

  sprintf(buf, "w >> /tmp/who%d", i);
  system(buf);


  sprintf(buf, "echo -e \"\n'ps' output:\n\" > /tmp/ps%d", i);
  system(buf);

  sprintf(buf, "ps -auxw >> /tmp/ps%d", i);
  system(buf);

  fclose(wee);

  sprintf(buf, "cat %s /tmp/netstat%d /tmp/last%d /tmp/who%d /tmp/ps%d "
               "| mail %s", fil, i, i, i, i, MAILUSER);
  system(buf);
  unlink(fil);

  sprintf(buf,"/tmp/netstat%d", i);
  unlink(buf);

  sprintf(buf,"/tmp/last%d", i);
  unlink(buf);

  sprintf(buf,"/tmp/who%d", i);
  unlink(buf);

  sprintf(buf,"/tmp/ps%d", i);
  unlink(buf);
}

char *gettime(void)
{
  time_t tmptime;
  static char timebuf[32];

  tmptime = time(NULL);
  strncpy(timebuf, ctime(&tmptime), sizeof(timebuf));
  strncpy(timebuf, &timebuf[11], sizeof(timebuf));

  timebuf[8] = 0;
  return &timebuf[0];
}
          

void trace_and_kill(int pid)
{
  int ppid;
  struct statusinfo *cppid;

  ppid = pid;

  while((cppid = getnextpid(ppid))) { 
    kill(ppid, 9);
    ppid  = cppid->ppid;

    cppid = getnextpid(ppid);
    if(cppid==NULL) break;

    if(cppid->ppid == 1) break;
  }
}

struct statusinfo *getnextpid(int pid)
{
  int  status;
  char buf[512];
  
  sprintf(buf, "/proc/%d/status", pid);

  if ((status = open(buf, O_RDONLY)) == ERROR) {
    perror("open");
    return NULL;
  }

  if ((read(status, buf, 512)) == ERROR) {
	perror("read");
	return NULL;
  }

  close(status);

  if (!*buf) return NULL;

  return woop(buf);
}

struct statusinfo *woop(char *buf)
{
  char *b;
  static struct statusinfo sinfo;

  b = getline(buf);
  stok(b, sinfo.cmd, 1);

  b = getline(buf);
  b = getline(buf);
  itok(b, &sinfo.pid, 1);

  b = getline(buf);
  itok(b, &sinfo.ppid, 1);

  b = getline(buf);
  itok(b, &sinfo.uid, 1);

  b = getline(buf);
  itok(b, &sinfo.euid, 2);

  return &sinfo;
}

char *getline(char *b)
{
  static char buf[512];
  char *p, i=0, doh[512];

  memcpy(buf, b, strlen(b)+1);

  for(p = &buf[0]; *p != '\n' && *p != '\0'; p++) i++;

  *p = 0;
  memcpy(doh, b, strlen(b)+1);
  p = &doh[++i];
  memcpy(b, p, strlen(p)+1);

  return buf;
}
